From 8cb82377f8975d0528367701cce0b5c9fbdd3e0e Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 06 2020 01:11:38 +0000
Subject: [PATCH 1297/2232] Merge pull request #426 from dtolnay/validate


Validate that `links` attribute is set if exporting headers
---

diff --git a/gen/build/src/error.rs b/gen/build/src/error.rs
index 260116f..5306564 100644
--- a/gen/build/src/error.rs
+++ b/gen/build/src/error.rs
@@ -13,6 +13,9 @@ pub(super) enum Error {
     Fs(fs::Error),
     ExportedDirNotAbsolute(&'static Path),
     ExportedEmptyPrefix,
+    ExportedDirsWithoutLinks,
+    ExportedPrefixesWithoutLinks,
+    ExportedLinksWithoutLinks,
 }
 
 macro_rules! expr {
@@ -22,6 +25,9 @@ macro_rules! expr {
     }};
 }
 
+const LINKS_DOCUMENTATION: &str =
+    "https://doc.rust-lang.org/cargo/reference/build-scripts.html#the-links-manifest-key";
+
 impl Display for Error {
     fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
         match self {
@@ -40,6 +46,24 @@ impl Display for Error {
                 "element of {} must not be empty string",
                 expr!(CFG.exported_header_prefixes),
             ),
+            Error::ExportedDirsWithoutLinks => write!(
+                f,
+                "if {} is nonempty then `links` needs to be set in Cargo.toml; see {}",
+                expr!(CFG.exported_header_dirs),
+                LINKS_DOCUMENTATION,
+            ),
+            Error::ExportedPrefixesWithoutLinks => write!(
+                f,
+                "if {} is nonempty then `links` needs to be set in Cargo.toml; see {}",
+                expr!(CFG.exported_header_prefixes),
+                LINKS_DOCUMENTATION,
+            ),
+            Error::ExportedLinksWithoutLinks => write!(
+                f,
+                "if {} is nonempty then `links` needs to be set in Cargo.toml; see {}",
+                expr!(CFG.exported_header_links),
+                LINKS_DOCUMENTATION,
+            ),
         }
     }
 }
diff --git a/gen/build/src/lib.rs b/gen/build/src/lib.rs
index 8097dec..b0df283 100644
--- a/gen/build/src/lib.rs
+++ b/gen/build/src/lib.rs
@@ -114,6 +114,8 @@ pub fn bridges(rust_source_files: impl IntoIterator<Item = impl AsRef<Path>>) ->
 struct Project {
     include_prefix: PathBuf,
     manifest_dir: PathBuf,
+    // The `links = "..."` value from Cargo.toml.
+    links_attribute: Option<OsString>,
     // Output directory as received from Cargo.
     out_dir: PathBuf,
     // Directory into which to symlink all generated code.
@@ -137,6 +139,8 @@ impl Project {
         assert!(include_prefix.is_relative());
         let include_prefix = include_prefix.components().collect();
 
+        let links_attribute = env::var_os("CARGO_MANIFEST_LINKS");
+
         let manifest_dir = paths::manifest_dir()?;
         let out_dir = paths::out_dir()?;
 
@@ -148,6 +152,7 @@ impl Project {
         Ok(Project {
             include_prefix,
             manifest_dir,
+            links_attribute,
             out_dir,
             shared_dir,
         })
@@ -177,9 +182,8 @@ impl Project {
 // current build as well as for downstream builds that have a direct dependency
 // on the current crate.
 fn build(rust_source_files: &mut dyn Iterator<Item = impl AsRef<Path>>) -> Result<Build> {
-    validate_cfg()?;
-
     let ref prj = Project::init()?;
+    validate_cfg(prj)?;
     let this_crate = make_this_crate(prj)?;
     this_crate.print_to_cargo();
 
@@ -204,7 +208,7 @@ fn build(rust_source_files: &mut dyn Iterator<Item = impl AsRef<Path>>) -> Resul
     Ok(build)
 }
 
-fn validate_cfg() -> Result<()> {
+fn validate_cfg(prj: &Project) -> Result<()> {
     for exported_dir in &CFG.exported_header_dirs {
         if !exported_dir.is_absolute() {
             return Err(Error::ExportedDirNotAbsolute(exported_dir));
@@ -217,6 +221,18 @@ fn validate_cfg() -> Result<()> {
         }
     }
 
+    if prj.links_attribute.is_none() {
+        if !CFG.exported_header_dirs.is_empty() {
+            return Err(Error::ExportedDirsWithoutLinks);
+        }
+        if !CFG.exported_header_prefixes.is_empty() {
+            return Err(Error::ExportedPrefixesWithoutLinks);
+        }
+        if !CFG.exported_header_links.is_empty() {
+            return Err(Error::ExportedLinksWithoutLinks);
+        }
+    }
+
     Ok(())
 }
 
@@ -226,7 +242,7 @@ fn make_this_crate(prj: &Project) -> Result<Crate> {
 
     let mut this_crate = Crate {
         include_prefix: Some(prj.include_prefix.clone()),
-        links: env::var_os("CARGO_MANIFEST_LINKS"),
+        links: prj.links_attribute.clone(),
         header_dirs: Vec::new(),
     };
 

